/* Libregresion is a numerical library written in standard C#
 * 
 * Libregresion is licensed under the terms of de GNU General Public License. 
 * 
 *(c) 2004, Jaime Anguiano Olarra <jaime@gnome.org>
 *         Fabian Seoane <fseoane@wanadoo.es>
 */


using System;


namespace Libregresion{
	
[Serializable]
public class LibregresionException : System.Exception {
	
	private double[,] matrix;
	string msg = null;

	public LibregresionException () {}

	public LibregresionException (string msg) : base (msg)
	{
		this.msg = msg;
	}

	public LibregresionException (string msg, double[,] matrix) : base (msg)
	{
		this.matrix = matrix;
		this.msg = msg;
	}

	public override String ToString()
	{
		return(this.msg+'\n');
	}
		

	public double[,] Matrix { get { return matrix; } }
}



[Serializable]
public class SingularMatrixException : System.Exception {
	public SingularMatrixException() {}
	public SingularMatrixException( string msg ) : base (msg) {}
}





public class Miscel{
	// en principio era Misc, pero confronta con Misc de GTK
	//metodos no especficos necesitados en diversos sitios

		public static void Swap( ref double a, ref double b)
		{	// Simplemente intercambia dos valores. Existe en la libreria estandar?
			double temp;
			temp = a;
			a = b;
			b = temp;
		}

		public static void Swap(ref int a, ref int b)
		{
			int temp;
			temp = a;
			a = b;
			b = temp;
		}
		
		public static void SwapRows( ref double[,] A, int n, int m)
		{
			for(int i = 0; i< A.GetLength(0); i++)
			{
				double temp;
				temp = A[n,i];
				A[n,i] = A[m,i];
				A[m,i] = temp;
			}
		}
		
		public static void SwapRows( ref Complex[,] A, int n, int m)
		{
			for(int i = 0; i< A.GetLength(0); i++)
			{
				Complex temp;
				temp = A[n,i];
				A[n,i] = A[m,i];
				A[m,i] = temp;
			}
		}
		
				
				
		
		public static void SwapPermutation( ref int[] P, int n, int m)
		{
			int temp = P[n];
			P[n] = P[m];
			P[m] = temp;
		}
		
			
		public static void Swap( ref Complex a, ref Complex b)
		{
			Complex temp;
			temp = a;
			a = b;
			b = temp;
		}
		
		
		public static Complex ConvertToComplex( string s )
		{
			Complex z = new Complex(0,0);
			char sep;
			string[] substring;
			switch( s.IndexOf("i"))
			{
				case -1:	// no hay parte imaginaria
					z.Re = Convert.ToDouble(s);
					return z;
				default:	// hay parte imaginaria
				       	// averiguemos el separador
				       	if( s.IndexOf("+") != -1 )
				       		sep = '+';
				 	else if( s.IndexOf("-") != -1)
						sep = '-';
					else 
					{	// solo hay parte imaginaria
						z.Im = Convert.ToDouble(s.Replace("i","") );
						return z;
					}

					substring = s.Split(sep);
					if( (substring[1]).IndexOf("i") != -1) 
					{
						substring[1] = substring[1].Replace("i","");
						z.Re = Convert.ToDouble( (substring[0]) );
						if( sep=='+')
							z.Im = Convert.ToDouble( substring[1] );
						else z.Im = - Convert.ToDouble( substring[1]  );
					}
					else 
						throw new LibregresionException("don't know how to convert that to complex");
					break;
				}
			return z;
			}	
	}




}


